summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--config/blobs/sources6
-rwxr-xr-xinclude/blobutil.sh5
-rwxr-xr-xinclude/mrc.sh82
-rwxr-xr-xscript/update/blobs/download14
-rwxr-xr-xscript/update/blobs/mrc143
5 files changed, 101 insertions, 149 deletions
diff --git a/config/blobs/sources b/config/blobs/sources
index ffba934e..31d9937e 100644
--- a/config/blobs/sources
+++ b/config/blobs/sources
@@ -21,10 +21,16 @@
DL_url_bkup https://web.archive.org/web/20220202201637/https://download.lenovo.com/ibmdl/pub/pc/pccbbs/mobiles/83rf46ww.exe
}
+# NOTE: google's manifest for archives containing mrc.bin, used here:
+# https://web.archive.org/web/20210211071412/https://dl.google.com/dl/edgedl/chromeos/recovery/recovery.conf
{t440pmrc w541mrc t440plibremrc w541}{
DL_hash f3d79aec805c8b0094a4081be76b3a22d329c479ad18210449b7acc3236ccfc4a2103eaa7c5b79a4872bfd699eede047efd46dfb06dc8f47e3216fc254612998
DL_url https://download.lenovo.com/pccbbs/mobiles/glrg22ww.exe
DL_url_bkup https://web.archive.org/web/20211120031520/https://download.lenovo.com/pccbbs/mobiles/glrg22ww.exe
+ MRC_url https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip
+ MRC_url_bkup https://web.archive.org/web/20200516070928/https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip
+ MRC_hash 340a1cd41136a3ba0de9d306db0e65f51640a2efe63aee9934f326b276adc1af0a2df80c0731c5a749161ec32546909eedfa8ba95801faeb5dcfe1aa4e0840c7
+ MRC_board peppy
}
{hp8200sff}{
diff --git a/include/blobutil.sh b/include/blobutil.sh
index 182ddf14..b85b8644 100755
--- a/include/blobutil.sh
+++ b/include/blobutil.sh
@@ -10,7 +10,8 @@ appdir="${blobdir}/app"
setvars="EC_url=\"\""
for x in EC_url_bkup EC_hash DL_hash DL_url DL_url_bkup E6400_VGA_DL_hash \
E6400_VGA_DL_url E6400_VGA_DL_url_bkup E6400_VGA_offset E6400_VGA_romname \
- SCH5545EC_DL_url SCH5545EC_DL_url_bkup SCH5545EC_DL_hash; do
+ SCH5545EC_DL_url SCH5545EC_DL_url_bkup SCH5545EC_DL_hash MRC_url \
+ MRC_url_bkup MRC_hash MRC_board; do
setvars="${setvars}; ${x}=\"\""
done
@@ -40,7 +41,7 @@ for x in _me_destination _gbe_destination _ifd_destination \
CONFIG_KBC1126_FW1_OFFSET CONFIG_KBC1126_FW2 CONFIG_KBC1126_FW2_OFFSET \
CONFIG_VGA_BIOS_FILE CONFIG_VGA_BIOS_ID CONFIG_GBE_BIN_PATH \
CONFIG_INCLUDE_SMSC_SCH5545_EC_FW CONFIG_SMSC_SCH5545_EC_FW_FILE \
- CONFIG_IFD_BIN_PATH; do
+ CONFIG_IFD_BIN_PATH CONFIG_MRC_FILE; do
setvars="${setvars}; ${x}=\"\""
done
diff --git a/include/mrc.sh b/include/mrc.sh
new file mode 100755
index 00000000..b9345b92
--- /dev/null
+++ b/include/mrc.sh
@@ -0,0 +1,82 @@
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Logic based on util/chromeos/crosfirmware.sh in coreboot cfc26ce278.
+# Modifications in this version are Copyright 2021 and 2023 Leah Rowe.
+# Original copyright detailed in repo: https://review.coreboot.org/coreboot/
+
+extract_mrc()
+{
+ [ -z "${MRC_board}" ] && err "extract_mrc $MRC_hash: MRC_board not set"
+ [ -z "${CONFIG_MRC_FILE}" ] && \
+ err "extract_mrc $MRC_hash: CONFIG_MRC_FILE not set"
+
+ _file="${MRC_url##*/}"
+ _file="${_file%.zip}"
+ _mrc_destination="${CONFIG_MRC_FILE#../../}"
+ mkdirs "${_mrc_destination}" "extract_mrc" || return 0
+
+ (
+ cd "${appdir}" || err "extract_mrc: !cd ${appdir}"
+ extract_partition ROOT-A "${_file}" root-a.ext2
+ extract_shellball root-a.ext2 chromeos-firmwareupdate-${MRC_board}
+ extract_coreboot chromeos-firmwareupdate-${MRC_board}
+ )
+
+ "${cbfstool}" "${appdir}/"coreboot-*.bin extract -n mrc.bin \
+ -f "${_mrc_destination}" -r RO_SECTION || \
+ err "extract_mrc: could not fetch mrc.bin"
+}
+
+extract_partition()
+{
+ NAME=${1}
+ FILE=${2}
+ ROOTFS=${3}
+ _bs=1024
+
+ printf "Extracting ROOT-A partition\n"
+ ROOTP=$( printf "unit\nB\nprint\nquit\n" | \
+ parted "${FILE}" 2>/dev/null | grep "${NAME}" )
+
+ START=$(( $( echo ${ROOTP} | cut -f2 -d\ | tr -d "B" ) ))
+ SIZE=$(( $( echo ${ROOTP} | cut -f4 -d\ | tr -d "B" ) ))
+
+ dd if="${FILE}" of="${ROOTFS}" bs=${_bs} skip=$(( ${START} / ${_bs} )) \
+ count=$(( ${SIZE} / ${_bs} )) || \
+ err "extract_partition: can't extract root file system"
+}
+
+extract_shellball()
+{
+ ROOTFS=${1}
+ SHELLBALL=${2}
+
+ printf "Extracting chromeos-firmwareupdate\n"
+ printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" \
+ | debugfs "${ROOTFS}" || err "extract_shellball: debugfs"
+}
+
+extract_coreboot()
+{
+ _shellball=${1}
+ _unpacked=$( mktemp -d )
+
+ printf "Extracting coreboot image\n"
+ [ -f "${_shellball}" ] || \
+ err "extract_coreboot: shellball missing in google cros image"
+ sh "${_shellball}" --unpack "${_unpacked}" || \
+ err "extract_coreboot: shellball exits with non-zero status"
+
+ # TODO: audit the f* out of that shellball, for each mrc version.
+ # it has to be updated for each mrc update. we should ideally
+ # implement the functionality ourselves.
+
+ [ -f "${_unpacked}/VERSION" ] || \
+ err "extract_coreboot: VERSION file missing on google coreboot rom"
+
+ _version=$( cat "${_unpacked}/VERSION" | grep BIOS\ version: | \
+ cut -f2 -d: | tr -d \ )
+
+ cp "${_unpacked}/bios.bin" "coreboot-${_version}.bin" || \
+ err "extract_coreboot: cannot copy google cros rom"
+}
diff --git a/script/update/blobs/download b/script/update/blobs/download
index e4c7b214..ca8302d2 100755
--- a/script/update/blobs/download
+++ b/script/update/blobs/download
@@ -8,6 +8,9 @@
. "include/defconfig.sh"
. "include/blobutil.sh"
. "include/fetch.sh"
+. "include/mrc.sh"
+
+export PATH="${PATH}:/sbin"
main()
{
@@ -58,10 +61,11 @@ build_dependencies()
done
[ -f uefitool/uefiextract ] || ./handle make file -b uefitool || \
err "build_dependencies: can't build uefitool"
- if [ ! -f "${cbdir}/util/kbc1126/kbc1126_ec_dump" ]; then
+ [ -f "${cbdir}/util/kbc1126/kbc1126_ec_dump" ] || \
make -C "${cbdir}/util/kbc1126" || \
err "build_dependencies: can't build kbc1126_ec_dump"
- fi
+ ./build coreboot utils default || \
+ err "build_dependencies: cannot build utils in cbutils/default/"
}
download_blobs()
@@ -81,7 +85,8 @@ download_blobs()
"${E6400_VGA_DL_url_bkup}" "${E6400_VGA_DL_hash}" \
"${blobdir}/cache/${E6400_VGA_DL_hash}" "err"
if [ ! -z "${CONFIG_HAVE_MRC}" ]; then
- ./update blobs mrc || err "download_blobs ${board}: !mrc"
+ fetch "mrc" "${MRC_url}" "${MRC_url_bkup}" "${MRC_hash}" \
+ "${blobdir}/cache/${MRC_hash}" "err"
fi
}
@@ -220,7 +225,8 @@ mkdirs()
extract_archive()
{
innoextract "${1}" -d "${2}" || python "${pfs_extract}" "${1}" -e || \
- 7z x "${1}" -o"${2}" || unar "${1}" -o "${2}" || return 1
+ 7z x "${1}" -o"${2}" || unar "${1}" -o "${2}" || \
+ unzip "${1}" -d "${2}" || return 1
}
main $@
diff --git a/script/update/blobs/mrc b/script/update/blobs/mrc
deleted file mode 100755
index f6c81390..00000000
--- a/script/update/blobs/mrc
+++ /dev/null
@@ -1,143 +0,0 @@
-#!/usr/bin/env sh
-# SPDX-License-Identifier: GPL-2.0-only
-
-# Forked from util/chromeos/crosfirmware.sh in coreboot cfc26ce278. Changes to
-# it in this version are exclusively by Leah Rowe, copyright as of 2021 and
-# 2023, on top of original coreboot copyright auditable in coreboot.git.
-
-[ "x${DEBUG+set}" = 'xset' ] && set -v
-set -u -e
-
-. "include/err.sh"
-. "include/fetch.sh"
-
-export PATH="${PATH}:/sbin"
-
-# use updated manifest from wayback machine, when updating mrc.bin,
-# and update the other variables below accordingly. current manifest used:
-# https://web.archive.org/web/20210211071412/https://dl.google.com/dl/edgedl/chromeos/recovery/recovery.conf
-
-# the wayback machine is used so that we get the same manifest. google
-# does not seem to version the manifest, but archives are available
-
-# variables taken from that manifest:
-
-_board="peppy"
-_file="chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin"
-_url="https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
-_url2="https://web.archive.org/web/20200516070928/https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
-_sha512sum="340a1cd41136a3ba0de9d306db0e65f51640a2efe63aee9934f326b276adc1af0a2df80c0731c5a749161ec32546909eedfa8ba95801faeb5dcfe1aa4e0840c7"
-_mrc_complete_hash="e5b6d510a5fdb6a7ba0027588dbceef363a2bf30255e9222020abbe71468822f49962d423d872cc05b37098682281c016445f6aa20f88351a134facfe5f70d5b"
-_mrc_complete="mrc/haswell/mrc.bin"
-
-# NOTE: the checksums, defined above, are actually sha-2 (sha512sum)
-# but google only defines sha1 and md5. we verify with sha1sum, but then
-# we use sha512sum in lbmk
-
-cbdir="coreboot/default"
-cbfstool="cbutils/default/cbfstool"
-
-sname=""
-
-main()
-{
- sname=${0}
- printf "Downloading Intel MRC blobs\n"
-
- vendor_checksum "${_mrc_complete_hash}" "${_mrc_complete}" && return 0
- build_dependencies
- fetch "mrc" "${_url}" "${_url2}" "${_sha512sum}" \
- "mrc/haswell/${_file}.zip" "err"
-}
-
-build_dependencies()
-{
- [ -d "${cbdir}/" ] || ./update project trees coreboot default || \
- err "build_dependencies: cannot fetch coreboot/default"
- ./build coreboot utils default || \
- err "build_dependencies: cannot build cbutils/default"
-}
-
-extract_mrc()
-{
- mkdir -p mrc/haswell/ || err "extract_mrc: !mkdir mrc/haswell"
-
- (
- cd mrc/haswell/ || err "extract_mrc: !cd mrc/haswell"
-
- unzip -q "${_file}.zip" || err "download_image: cannot unzip"
- rm -f "${_file}.zip" || err "download_image: can't rm zip {1}"
-
- extract_partition ROOT-A "${_file}" root-a.ext2
- extract_shellball root-a.ext2 chromeos-firmwareupdate-${_board}
-
- extract_coreboot chromeos-firmwareupdate-${_board}
-
- ../../"${cbfstool}" coreboot-*.bin extract -f mrc.bin -n mrc.bin \
- -r RO_SECTION || err "extract_mrc: could not fetch mrc.bin"
- rm -f "chromeos-firmwareupdate-${_board}" coreboot-*.bin \
- "${_file}" "root-a.ext2" || err "extract_mrc: cannot remove files"
-
- printf "\n\nmrc.bin saved to ${_mrc_complete}\n\n"
- )
-}
-
-extract_partition()
-{
- NAME=${1}
- FILE=${2}
- ROOTFS=${3}
- _bs=1024
-
- printf "Extracting ROOT-A partition\n"
- ROOTP=$( printf "unit\nB\nprint\nquit\n" | \
- parted "${FILE}" 2>/dev/null | grep "${NAME}" )
-
- START=$(( $( echo ${ROOTP} | cut -f2 -d\ | tr -d "B" ) ))
- SIZE=$(( $( echo ${ROOTP} | cut -f4 -d\ | tr -d "B" ) ))
-
- dd if="${FILE}" of="${ROOTFS}" bs=${_bs} skip=$(( ${START} / ${_bs} )) \
- count=$(( ${SIZE} / ${_bs} )) || \
- err "extract_partition: can't extract root file system"
-}
-
-extract_shellball()
-{
- ROOTFS=${1}
- SHELLBALL=${2}
-
- printf "Extracting chromeos-firmwareupdate\n"
- printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" \
- | debugfs "${ROOTFS}" || err "extract_shellball: debugfs"
-}
-
-extract_coreboot()
-{
- _shellball=${1}
- _unpacked=$( mktemp -d )
-
- printf "Extracting coreboot image\n"
-
- [ -f "${_shellball}" ] || \
- err "extract_coreboot: shellball missing in google peppy image"
-
- sh "${_shellball}" --unpack "${_unpacked}" || \
- err "extract_coreboot: shellball exits with non-zero status"
-
- # TODO: audit the f* out of that shellball, for each mrc version.
- # it has to be updated for each mrc update. we should ideally
- # implement the functionality ourselves.
-
- [ -f "${_unpacked}/VERSION" ] || \
- err "extract_coreboot: VERSION file missing on google coreboot rom"
-
- _version=$( cat "${_unpacked}/VERSION" | grep BIOS\ version: | \
- cut -f2 -d: | tr -d \ )
-
- cp "${_unpacked}/bios.bin" "coreboot-${_version}.bin" || \
- err "extract_coreboot: cannot copy google peppy rom"
- rm -Rf "${_unpacked}" || \
- err "extract_coreboot: cannot remove extracted google peppy archive"
-}
-
-main $@